%let rep=%str(C:\Users\FSEG\Documents\Panel_ES);

options macrogen;
%put(&rep);
run;

libname rep "&rep";

proc import datafile="&rep\prod_1991.csv"
dbms=DLM
replace
out=t1991;
delimiter=";";
run;

%macro boucle;
%do an=1991 %to 1995;
proc import datafile="&rep\prod_&an.csv" /* avec erreur = 1 seul point*/
dbms=DLM
replace
out=t&an;
delimiter=";";
%end;
%mend;

%macro boucle;
%do an=1991 %to 1995;
proc import datafile="&rep\prod_&an..csv" /* sans erreur = 2  points*/
dbms=DLM
replace
out=t&an;
delimiter=";";
%end;
%mend;
%boucle; run;


%macro boucle;
%do an=1991 %to 1995;
proc import datafile="&rep\prod_&an..csv" /* sans erreur = 2  points*/
dbms=DLM
replace
out=rep.t&an; /* permanent */
delimiter=";";
%end;
%mend;
%boucle; run;

/* panel brut */
data tab; set t1991 t1992 t1993 t1994 t1995;
run; 

/* liste */
%macro liste;
%do an=1991 %to 1995;
t&an; /* avec erreur = 1 point virgule */
%end;
%mend;

%macro liste;
%do an=1991 %to 1995;
t&an /* sans point virgule */
%end;
%mend;
data tab; set %liste;
run;

/* sur le disque */
%macro liste;
%do an=1991 %to 1995;
rep.t&an /* sans point virgule */
%end;
%mend;
data rep.panel_brut; set %liste;
run;

proc sort data=tab; by cusip; /* i=cusip, t=year */
proc means NOPRINT data=tab; by cusip; var year;
output out=stat1 min=entree max=sortie n=nobs;
run;
proc freq; tables entree sortie nobs;
run;
proc freq; tables entree*sortie;
run;
data stat1; set stat1;
manq=(sortie-entree+1)-nobs;
run;
proc freq; tables manq;
run;
/* profil - astuce */
data tab; set tab; pres=1; 
proc transpose data=tab out=tab2 prefix=d; by cusip; var pres; id year;
run;

%macro dum;
%do an=1991 %to 1995;
d&an=max(0,d&an);/* il faut un point virgule */
%end;
%mend;

data tab2; set tab2; %dum; run;

data tab3; set tab2;
profil=compress(d1991||d1992||d1993||d1994||d1995);
run;
proc freq; tables profil;
run;

%macro profil;
%do an=1992 %to 1995;
||d&an /* sans point-virgule */
%end;
%mend;

data tab3; set tab2;
profil=compress(d1991%profil);
run;
proc freq; tables profil;
run;

data tab;
merge tab stat1(keep=cusip manq nobs) tab3(keep=cusip profil);
by cusip;
run;

data pbs; set tab; if manq;
proc freq; tables profil;
run;

data rep.panel_ech; /* chancr avec au moins deux points */
set tab;
if nobs=1 then delete;
if compress(profil)="01101" and year>=1994 then delete;
if compress(profil)="11011" and year>=1993 then delete;
if compress(profil)="11101" and year>=1994 then delete;
run; 
